const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const workplanMonitorService = require("./workplanMonitor.service");

router.post("/create", authorize(), create);
router.get("/", authorize(), getAll);
router.get("/filter", authorize(), filter);
router.get("/get-by-emp", authorize(), getByEmpID);
router.get("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/progress/:id", authorize(), updateProgressList);
router.put("/:id", authorize(), update);
router.put("/enabled/:id", authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
  workplanMonitorService
    .create(req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function getAll(req, res, next) {
  workplanMonitorService
    .getAll()
    .then((result) => res.json(result))
    .catch(next);
}

function filter(req, res, next) {
  workplanMonitorService
    .filter(req.query)
    .then((result) => res.json(result))
    .catch(next);
}
function getByEmpID(req, res, next) {
  workplanMonitorService
    .getByEmpID(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

function option(req, res, next) {
  workplanMonitorService
    .option()
    .then((result) => res.json(result))
    .catch(next);
}

function count(req, res, next) {
  workplanMonitorService
    .count()
    .then((result) => res.json(result))
    .catch(next);
}

function update(req, res, next) {
  workplanMonitorService
    .update(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function updateProgressList(req, res, next) {
  workplanMonitorService
    .updateProgressList(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function enabled(req, res, next) {
  workplanMonitorService
    .enabled(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function _delete(req, res, next) {
  workplanMonitorService
    .delete(req.params.id)
    .then((result) => res.json(result))
    .catch(next);
}
